/*--------------------------------------------------------------------------
   VGA_C1.c
  --------------------------------------------------------------------------
   Este programa es muy simple. Sin embargo muestra bastantes cosas que son
   interesantes para empezar. En particular hace uso de una tecnica que el
   lector mas avispado puede haber intuido tras leer el texto. En el texto
   VGA_TUT1.TXT se dice como acceder a las cuatro paginas a las que tenemos
   acceso. Para ello solo hay que decirle donde comienza el desplazamiento,
   en la memoria de video, de la pagina que queramos ver. Tambien se dice
   que estas paginas estan contiguas, por lo que si empezamos a visualizar
   la primera pagina por la linea X, veremos las siguientes 200-X lineas de
   la primera pagina y las X primeras de la segunda.
   Lo que yo he hecho aqui es 'pegar' esas 4 paginas y tratarlas como una
   pagina cuatro veces mas larga de lo normal. La pinto de colorines y la
   voy viendo de arriba a abajo con robotes incluidos. Fijate lo suave que
   es el scroll. Aun lo puede ser mas... mejorando la rutina.
   Ese 'pegar' paginas no es un concepto correcto. Lo que he hecho es coger
   las 256k de la VGA y las he dispuesto en una pantalla virtual de 320x800.
   Pero de esto... ya hablare mas y mejor en proximos tutoriales.
  --------------------------------------------------------------------------*/

/* Necesitamos la funcion seno */
#include <math.h>

/* Por si no esta definida en math.h */
#define PI 3.141592

void Set320x200NE1( void );
void SetPixelNE1(int x, int y, int color);
void SetTextMode80C( void );
void SetStartAdress( int despl );
void DrawBox(int x, int y, int ancho, int alto, int color);


/*--------------------------------------------------------------------------
  Funcion principal
  --------------------------------------------------------------------------
  Rellena la pantalla virtual y despues desplaza la ventana de visualizacion
  segun una funcion sin^2(x).
  --------------------------------------------------------------------------*/
main()
{
 unsigned x,y,retraso;
 double rad,func;

 /* Establecemos el modo no encadenado */
	Set320x200NE1();

 /* Llenamos la pantalla virtual de rectangulos de colores */
	for(x=0;x<16;++x){
	for(y=0;y<16;++y){
	   DrawBox(30+x*10,y*50,10,50,y+x*16);
	}}

 /* Movemos la ventana */
	for(rad=0;rad<8*PI;rad+=0.005){
	   func=sin(rad);
	   SetStartAdress((unsigned)(80*((unsigned)(600*func*func)) ));
	}

 /* Restablecemos el modo de texto */
	SetTextMode80C();
}


/*--------------------------------------------------------------------------
   DrawBox - Dibuja un cuadrado en la pantalla virtual del color escogido
  --------------------------------------------------------------------------*/
void DrawBox(int x, int y, int ancho, int alto, int color)
{
 unsigned cx,cy;
 for(cx=0;cx<ancho;++cx){
 for(cy=0;cy<alto;++cy){ SetPixelNE1(x+cx,y+cy,color); }}
}

